update sp_vid_lgots set yy_end=2024
where code='127' and summa = 1400 and ISNULL(yy_end,2050) > 2024
go
if not exists(select 1 from sp_vid_lgots where code='127' and summa=2800)
  insert sp_vid_lgots(key_f, code, name, koef, summa, if_dohod, tip_ucheta, is_uchet_out_dohod,
                      id_year, is_always, koef_scal, fl_child, ochered, yy_begin)
  select '127_2025', code, name, koef, 2800, if_dohod, tip_ucheta, is_uchet_out_dohod,
                      id_year, is_always, koef_scal, fl_child, ochered, 2025
  from sp_vid_lgots where code='127' and id_year='2' and summa=1400                    
go

update sp_vid_lgots set yy_end=2024
where code='128' and summa = 3000 and ISNULL(yy_end,2050) > 2024
go
if not exists(select 1 from sp_vid_lgots where code='128' and summa=6000)
  insert sp_vid_lgots(key_f, code, name, koef, summa, if_dohod, tip_ucheta, is_uchet_out_dohod,
                      id_year, is_always, koef_scal, fl_child, ochered, yy_begin)
  select '128_2025', code, name, koef, 6000, if_dohod, tip_ucheta, is_uchet_out_dohod,
                      id_year, is_always, koef_scal, fl_child, ochered, 2025
  from sp_vid_lgots where code='128' and id_year='2' and summa=3000                    
go

update sp_vid_lgots set yy_end=2024
where code='133' and summa = 6000 and ISNULL(yy_end,2050) > 2024
go
if not exists(select 1 from sp_vid_lgots where code='133' and summa=12000)
  insert sp_vid_lgots(key_f, code, name, koef, summa, if_dohod, tip_ucheta, is_uchet_out_dohod,
                      id_year, is_always, koef_scal, fl_child, ochered, yy_begin)
  select '133_2025', code, name, koef, 12000, if_dohod, tip_ucheta, is_uchet_out_dohod,
                      id_year, is_always, koef_scal, fl_child, ochered, 2025
  from sp_vid_lgots where code='133' and id_year='2' and summa=6000                    
go

insert nall(key_f, pers_id, vid_lgots, koef, summa, if_dohod, d_begin, d_end, is_child, osn1, osn2, osn3, osn_date) 
select '27_25_'+CONVERT(varchar,ROW_NUMBER() over(order by pers_id)), pers_id, 
       (select min(key_f) from sp_vid_lgots where code='127' and summa=2800),
       koef, 2800, if_dohod, '20250101', d_end, is_child, osn1, osn2, osn3, osn_date 
from nall
where ISNULL(d_end,'20500101')>'20241231' and isnull(d_begin,'19500101')<'20250101'
  and vid_lgots in (select key_f from sp_vid_lgots where code ='127' and yy_end=2024)
go
insert nall(key_f, pers_id, vid_lgots, koef, summa, if_dohod, d_begin, d_end, is_child, osn1, osn2, osn3, osn_date) 
select '28_25_'+CONVERT(varchar,ROW_NUMBER() over(order by pers_id)), pers_id, 
       (select min(key_f) from sp_vid_lgots where code='128' and summa=6000),
       koef, 6000, if_dohod, '20250101', d_end, is_child, osn1, osn2, osn3, osn_date 
from nall
where ISNULL(d_end,'20500101')>'20241231' and isnull(d_begin,'19500101')<'20250101'
  and vid_lgots in (select key_f from sp_vid_lgots where code ='128' and yy_end=2024)
go
insert nall(key_f, pers_id, vid_lgots, koef, summa, if_dohod, d_begin, d_end, is_child, osn1, osn2, osn3, osn_date) 
select '33_25_'+CONVERT(varchar,ROW_NUMBER() over(order by pers_id)), pers_id, 
       (select min(key_f) from sp_vid_lgots where code='133' and summa=12000),
       koef, 12000, if_dohod, '20250101', d_end, is_child, osn1, osn2, osn3, osn_date 
from nall
where ISNULL(d_end,'20500101')>'20241231' and isnull(d_begin,'19500101')<'20250101'
  and vid_lgots in (select key_f from sp_vid_lgots where code ='133' and yy_end=2024)
go
update nall set d_end='20241231'
where ISNULL(d_end,'20500101')>'20241231' and isnull(d_begin,'19500101')<'20250101'
  and vid_lgots in (select key_f from sp_vid_lgots where code in ('127','128','133') and yy_end=2024)   
go                    
